local function SaveFile(player)
local splus = player.shadowplus
local scfg = io.openlocal("client/Shadow+.dat", "w+")
scfg:write("s+_custombutton "..splus.shadowcfg_cb.."\ns+_controlscheme "..splus.shadowcfg.."\ns+_homingtype "..splus.homing.."\ns+_cstype "..splus.teleport)
scfg:close()
end

local ControlScheme_table = {
	[1] = "plus",
	[2] = "invert",
	[3] = "hybrid"
}

local CustomButton_table = {
	[1] = {"1", "Custom 1"},
	[2] = {"2", "Custom 2"},
	[3] = {"3", "Custom 3"},
	[4] = {"4", "Toss Flag"},
	[5] = {"5", "Fire Normal"},
	[6] = {"6", "Fire"}
}

local HomingType_table = {
	[1] = "hold",
	[2] = "move"
}

local ChaosSnapType_table = {
	[1] = "free",
	[2] = "angle"
}

COM_AddCommand("s+_menu", function(player)
	if player
	and player.valid
		if player.splus_menu == false
		player.splus_menu = true
		else
		player.splus_menu = false
		end
	end
end)

local function ControlHandler(player)
local cmd = player.splus
	if player.cmd.buttons & BT_JUMP
	cmd.accept = true
	else
	cmd.accept = false
	end
	if player.cmd.buttons & BT_SPIN
	cmd.cancel = true
	else
	cmd.cancel = false
	end
	if player.cmd.forwardmove != 0
		if player.cmd.forwardmove > 25
		cmd.up = true
		else
		cmd.up = false
		end
		if player.cmd.forwardmove < -25
		cmd.down = true
		else
		cmd.down = false
		end
	else
	cmd.up = false
	cmd.down = false
	end
	if player.cmd.sidemove != 0
		if player.cmd.sidemove > 25
		cmd.right = true
		else
		cmd.right = false
		end
		if player.cmd.sidemove < -25
		cmd.left = true
		else
		cmd.left = false
		end
	else
	cmd.left = false
	cmd.right = false
	end
player.cmd.forwardmove = 0
player.cmd.sidemove = 0
player.cmd.buttons = 0
end

addHook("PreThinkFrame", function(player)
	for player in players.iterate
		if player
		and player.valid
			if player.shadowplus
			and player.shadowplus != nil
				if player.shadowplus.shadowcfg != "classic"
					if player.splus_menu == nil
					player.splus_menu = false
					else
						if player.splus_menu == true
							if player.splus == nil
							player.splus = {
								point = 1,
								up = false,
								down = false,
								left = false,
								right = false,
								accept = false,
								cancel = false
							}
							end
							if player.splus_things == nil
							player.splus_things = {
								cfgtype = 1,
								custom = 1,
								homing = 1,
								cstype = 1
							}
							end
							if player.shadowplus
								local splus = player.shadowplus
								if splus.shadowcfg == "plus"
									player.splus_things.cfgtype = 1
								elseif splus.shadowcfg == "invert"
									player.splus_things.cfgtype = 2
								elseif splus.shadowcfg == "hybrid"
									player.splus_things.cfgtype = 3
								end
								player.splus_things.custom = tonumber(splus.shadowcfg_cb)
								if splus.homing == "hold"
									player.splus_things.homing = 1
								elseif splus.homing == "move"
									player.splus_things.homing = 2
								end
								if splus.teleport == "free"
									player.splus_things.cstype = 1
								elseif splus.teleport == "angle"
									player.splus_things.cstype = 2
								end
							end
						local splus = player.splus
						local cmdline = player.splus_things
							if player.cmd.forwardmove > 25
							and splus.up == false
							splus.point = max($-1, 1)
							S_StartSound(nil, sfx_menu1, player)
							end
							if player.cmd.forwardmove < -25
							and splus.down == false
							splus.point = min($+1, 5)
							S_StartSound(nil, sfx_menu1, player)
							end
							if player.cmd.sidemove > 25
							and splus.right == false
							S_StartSound(nil, sfx_menu1, player)
								if splus.point == 1
								//COM_BufInsertText(player, "s+_controlscheme "..ControlScheme_table[min(player.splus_things.cfgtype+1, 3)])
								player.shadowplus.shadowcfg = ControlScheme_table[min(player.splus_things.cfgtype+1, 3)]
								elseif splus.point == 2
								//COM_BufInsertText(player, "s+_custombutton "..CustomButton_table[min(player.splus_things.custom+1, 6)][1])
								player.shadowplus.shadowcfg_cb = CustomButton_table[min(player.splus_things.custom+1, 6)][1]
								elseif splus.point == 3
								//COM_BufInsertText(player, "s+_homingtype "..HomingType_table[min(player.splus_things.homing+1, 2)])
								player.shadowplus.homing = HomingType_table[min(player.splus_things.homing+1, 2)]
								elseif splus.point == 4
								//COM_BufInsertText(player, "s+_cstype "..ChaosSnapType_table[min(player.splus_things.cstype+1, 2)])
								player.shadowplus.teleport = ChaosSnapType_table[min(player.splus_things.cstype+1, 2)]
								end
							SaveFile(player)
							end
							if player.cmd.sidemove < -25
							and splus.left == false
							S_StartSound(nil, sfx_menu1, player)
								if splus.point == 1
								//COM_BufInsertText(player, "s+_controlscheme "..ControlScheme_table[max(player.splus_things.cfgtype-1, 1)])
								player.shadowplus.shadowcfg = ControlScheme_table[max(player.splus_things.cfgtype-1, 1)]
								elseif splus.point == 2
								//COM_BufInsertText(player, "s+_custombutton "..CustomButton_table[max(player.splus_things.custom-1, 1)][1])
								player.shadowplus.shadowcfg_cb = CustomButton_table[max(player.splus_things.custom-1, 1)][1]
								elseif splus.point == 3
								//COM_BufInsertText(player, "s+_homingtype "..HomingType_table[max(player.splus_things.homing-1, 1)])
								player.shadowplus.homing = HomingType_table[max(player.splus_things.homing-1, 1)]
								elseif splus.point == 4
								//COM_BufInsertText(player, "s+_cstype "..ChaosSnapType_table[max(player.splus_things.cstype-1, 1)])
								player.shadowplus.teleport = ChaosSnapType_table[max(player.splus_things.cstype-1, 1)]
								end
							SaveFile(player)
							end
							if player.cmd.buttons & BT_JUMP
							and splus.accept == false
							and splus.point == 5
							S_StartSound(nil, sfx_altdi1, player)
							COM_BufInsertText(player, "s+_resetcfg")
							end
						ControlHandler(player)
						else
						player.splus_things = nil
						player.splus = nil
						end
					end
				else
					if player.splus_menu == nil
					player.splus_menu = false
					end
				player.splus_things = nil
				player.splus = nil
				end
			end
		end
	end
end)

local function ShowCurrentParameters(v, player)
	if player.splus_things
	and player.splus_things != nil
	local cfg_text = "\x82"..string.upper(ControlScheme_table[player.splus_things.cfgtype])
	local custombutton_text = "\x82"..string.upper(CustomButton_table[player.splus_things.custom][2])
	local homing_text = "\x82"..string.upper(HomingType_table[player.splus_things.homing])
	local cs_text = "\x82"..string.upper(ChaosSnapType_table[player.splus_things.cstype])
	v.drawString(96, 64, "Control Scheme: "..cfg_text, V_ALLOWLOWERCASE)
	v.drawString(96, 80, "Custom Button: "..custombutton_text, V_ALLOWLOWERCASE)
	v.drawString(96, 96, "Homing Type: "..homing_text, V_ALLOWLOWERCASE)
	v.drawString(96, 112, "Chaos Snap Type: "..cs_text, V_ALLOWLOWERCASE)
	end
end

local function ShadowPlus_Menu(v, player, camera)
	if player
	and player.valid
		if player.shadowplus
		and player.shadowplus != nil
			if player.shadowplus.shadowcfg != "classic"
				if player.splus_menu == true
				and (player.splus and player.splus != nil)
				//v.fadeScreen(31, 5)
				v.drawScaled(160*FRACUNIT, 100*FRACUNIT, FRACUNIT, v.cachePatch("GAMEDEVELOPMENT"), V_50TRANS)
				v.drawLevelTitle(120, 8, "Menu", V_YELLOWMAP)
				v.drawString(160, 144, "Reset Config", V_ALLOWLOWERCASE, "center")
				ShowCurrentParameters(v, player)
					if player.splus.point == 1
					v.drawString(96, 64, "Control Scheme:", V_ALLOWLOWERCASE|V_YELLOWMAP)
					elseif player.splus.point == 2
					v.drawString(96, 80, "Custom Button:", V_ALLOWLOWERCASE|V_YELLOWMAP)
					elseif player.splus.point == 3
					v.drawString(96, 96, "Homing Type:", V_ALLOWLOWERCASE|V_YELLOWMAP)
					elseif player.splus.point == 4
					v.drawString(96, 112, "Chaos Snap Type:", V_ALLOWLOWERCASE|V_YELLOWMAP)
					elseif player.splus.point == 5
					v.drawString(160, 144, "Reset Config", V_ALLOWLOWERCASE|V_YELLOWMAP, "center")
					end
					if player.splus.point != 5
					v.draw(76, 64+(16*(player.splus.point-1)), v.cachePatch("M_CURSOR"))
					else
					v.draw(90, 144, v.cachePatch("M_CURSOR"))
					end
				end
			else
				if player.splus_menu == true
				v.fadeScreen(31, 8)
				v.drawLevelTitle(90, 90, "GIT GUD", V_REDMAP)
				end
			end
		end
	end
end

hud.add(ShadowPlus_Menu, "game")